---------------------------- MODULE LinInterface ----------------------------

EXTENDS Library

CONSTANTS P, C, S, O
VARIABLE interface

InvInterfaceType == [P -> [cmd: C, flag: BOOLEAN]]
RespInterfaceType == [P -> [output: O, flag: BOOLEAN]]

InterfaceType == [
    inv: InvInterfaceType, 
    resp: RespInterfaceType ]
    
InvInterfaceInit == [p\in P |-> [
    cmd |-> Some(C), 
    flag |-> Some(BOOLEAN)]]
    
RespInterfaceInit == [p \in P |-> [
    output |-> Some(O), 
    flag |-> Some(BOOLEAN)]]
    
InterfaceInit == [
    inv |-> InvInterfaceInit, 
    resp |-> RespInterfaceInit ]

Invoke(p, cmd) == 
    interface' = [interface EXCEPT !.inv = [@ EXCEPT ![p] = [
        cmd |-> cmd, 
        flag |-> \neg @.flag]]]

Response(p, o) == 
    interface' = [interface EXCEPT !.resp = [@ EXCEPT ![p] = [
        output |-> o, 
        flag |-> \neg @.flag]]] 

=============================================================================
\* Modification History
\* Last modified Fri Nov 29 14:55:01 CET 2013 by losa
\* Last modified Wed Nov 13 16:11:18 CET 2013 by nano
\* Created Wed Nov 13 14:56:49 CET 2013 by nano
