---------------------------- MODULE SafeMPGCDefs ----------------------------

EXTENDS FiniteSets, Library

CONSTANTS _ \preceq _, GLB(_)

CONSTANTS Acceptor

N == Cardinality(Acceptor)
Quorum ==
  {Q \in SUBSET Acceptor : 
    Cardinality(Q) \geq (N \div 2) + 1}
RespQuorum == Quorum
AbortQuorum == Quorum

ASSUME \A Q,R \in RespQuorum : Q \intersect R # {}
ASSUME \A Q \in RespQuorum, R \in AbortQuorum : 
  Cardinality(Q \intersect R) \geq (Cardinality(R) \div 2) + 1

\* There is only one abort value, the maximum of the dStates of the quorum.
AbortValues(DStates) ==
  {CHOOSE s \in Image(DStates) :
    \A s1 \in Image(DStates) : 
      s1 \preceq s}

=============================================================================
\* Modification History
\* Last modified Fri Nov 29 18:52:40 CET 2013 by losa
\* Created Fri Nov 29 18:50:15 CET 2013 by losa
