-------------------------- MODULE SpecLinInterface --------------------------

EXTENDS Library

CONSTANTS P, C, S, O

VARIABLE interface

LI == INSTANCE LinInterface

SwitchInterfaceType == [P -> [cmd:C, sval:S, flag: BOOLEAN]]

InterfaceType == [
    init:  SwitchInterfaceType, 
    inv: LI!InvInterfaceType, 
    resp: LI!RespInterfaceType, 
    abort: SwitchInterfaceType]

SwitchInterfaceInit == [p\in P |-> [
    cmd |-> Some(C), 
    sval |-> Some(S),
    flag |-> Some(BOOLEAN)] ]
    
InterfaceInit == [
    init |-> SwitchInterfaceInit, 
    inv |-> LI!InvInterfaceInit, 
    resp |-> LI!RespInterfaceInit, 
    abort |-> SwitchInterfaceInit]

Invoke(p, cmd) == LI!Invoke(p, cmd) 

Response(p, o) == LI!Response(p, o)  
        
Initialize(p, cmd, sv) == 
    interface' = [interface EXCEPT !.init = [ @ EXCEPT ![p] = [
        cmd |-> cmd,
        sval |-> sv, 
        flag |-> \neg @.flag] ] ]

Abort(p, cmd, sv) == 
    interface' = [interface EXCEPT !.abort = [ @ EXCEPT ![p] = [
        cmd |-> cmd, 
        sval |-> sv, 
        flag |-> \neg @.flag] ] ]

=============================================================================
\* Modification History
\* Last modified Fri Nov 29 14:54:22 CET 2013 by losa
\* Last modified Wed Nov 13 16:12:15 CET 2013 by nano
\* Created Sun Nov 10 19:44:57 CET 2013 by nano
